package jumpstart.max.business;

import jumpstart.max.business.commons.exception.TestAddWhatException;
import jumpstart.max.business.commons.exception.TestCannotDeleteIsNotEmptyException;
import jumpstart.max.business.commons.exception.TestCannotDeleteIsReferencedException;
import jumpstart.max.business.commons.exception.TestDoesNotExistException;
import jumpstart.max.business.commons.exception.TestDuplicateAlternateKeyException;
import jumpstart.max.business.commons.exception.TestDuplicatePrimaryKeyException;
import jumpstart.max.business.commons.exception.TestOptimisticLockException;
import jumpstart.max.business.commons.exception.TestReferenceNotResettableException;
import jumpstart.max.business.commons.exception.TestReferencesWrongSubsetException;
import jumpstart.max.business.commons.exception.TestRemoveWhatException;
import jumpstart.max.business.commons.exception.TestValueRequiredException;
import jumpstart.max.business.commons.query.TestQueryBuilder;
import jumpstart.max.business.domain.security.TestUserPassword;
import junit.framework.Test;
import junit.framework.TestSuite;

public class BusinessTestSuite {

	public static Test suite() {
		TestSuite suite = new TestSuite("Test jumpstart.business");
		// $JUnit-BEGIN$

		suite.addTest(new TestSuite(TestQueryBuilder.class));

		suite.addTest(new TestSuite(TestAddWhatException.class));
		suite.addTest(new TestSuite(TestCannotDeleteIsNotEmptyException.class));
		suite.addTest(new TestSuite(TestCannotDeleteIsReferencedException.class));
		suite.addTest(new TestSuite(TestDoesNotExistException.class));
		suite.addTest(new TestSuite(TestDuplicateAlternateKeyException.class));
		suite.addTest(new TestSuite(TestDuplicatePrimaryKeyException.class));
		suite.addTest(new TestSuite(TestOptimisticLockException.class));
		suite.addTest(new TestSuite(TestReferenceNotResettableException.class));
		suite.addTest(new TestSuite(TestReferencesWrongSubsetException.class));
		suite.addTest(new TestSuite(TestRemoveWhatException.class));
		suite.addTest(new TestSuite(TestValueRequiredException.class));

		suite.addTest(new TestSuite(TestUserPassword.class));

		// $JUnit-END$
		return suite;
	}
}
