package jumpstart.max.business.commons.exception;

import jumpstart.max.business.BaseTest;
import jumpstart.max.business.commons.exception.ReferencesWrongSubsetException;
import jumpstart.max.business.commons.exception.ServiceException;
import jumpstart.max.business.domain.reference.Code;
import jumpstart.max.business.domain.reference.CodeGroup;

public class TestReferencesWrongSubsetException extends BaseTest {

	public TestReferencesWrongSubsetException(String arg0) {
		super(arg0);
	}

	public static void main(String[] args) {
		junit.textui.TestRunner.run(TestReferencesWrongSubsetException.class);
	}

	public void test_ReferencesWrongSubsetException_is_thrown_on_referencing_a_part_of_wrong_whole() {

		try {
			CodeGroup cg = new CodeGroup();
			
			cg.setId("garbage");
			cg.setDescription("x");
			cg.setShortDescription("y");
			Code c1 = _referenceFinderSvc.findCodeShallowish("usr_active");
			cg.setStatus(c1);

			_referenceManagerSvc.createCodeGroup(cg);
			fail("Should not reach here");
		}
		catch (Exception e) {
			ServiceException s = _interpreter.interpret(e);
			assertEquals(s.getMessage(), ReferencesWrongSubsetException.class, s.getClass());
			assertEquals("Status is not allowed because  does not belong to Code Group \"cgr_status\".  It belongs to Code Group \"usr_status\".",
					s.getLocalizedMessage());
		}

	}

	public void test_ReferencesWrongSubsetException_is_thrown_on_referencing_a_part_of_wrong_whole_while_detached() {

		try {
			CodeGroup cg = new CodeGroup();
			
			cg.setId("garbage");
			cg.setDescription("x");
			cg.setShortDescription("y");
			Code c1 = _referenceFinderSvc.findCodeShallowish("usr_active");
			cg.setStatus(c1);

			cg.validateCodeGroup();
			fail("Should not reach here");
		}
		catch (Exception e) {
			assertEquals(e.getMessage(), ReferencesWrongSubsetException.class, e.getClass());
			assertEquals("Status is not allowed because  does not belong to Code Group \"cgr_status\".  It belongs to Code Group \"usr_status\".",
					e.getLocalizedMessage());
		}

	}

}
