package jumpstart.max.web.pages.starters;

import java.util.List;

import jumpstart.max.business.domain.security.User;
import jumpstart.max.business.domain.security.iface.ISecurityFinderSvcLocal;
import jumpstart.max.web.pages.login.LoginPage;
import jumpstart.max.web.state.BizServicesLocator;

import org.apache.tapestry.IAsset;
import org.apache.tapestry.annotations.Asset;
import org.apache.tapestry.annotations.InjectState;
import org.apache.tapestry.annotations.Persist;
import org.apache.tapestry.html.BasePage;

public abstract class PreviewableTablePage extends BasePage {
	static public final String PAGE_NAME = "pages/starters/PreviewableTablePage";

	@Asset("context:/css/starters.css")
	public abstract IAsset getStylesheet();

	@InjectState("bizServicesLocator")
	public abstract BizServicesLocator getBizServicesLocator();

	@Persist
	public abstract void setUsers(List<User> value);

	public abstract void setUser(User value);

	public void activate() {
		// Get all users - ask business tier to find them (from the database)
		ISecurityFinderSvcLocal finder = getBizServicesLocator().getSecurityFinderSvcLocal();
		List<User> l = finder.findUsersShallowish();
		setUsers(l);

		getRequestCycle().activate(this);
	}

	public void doToLogin() {
		LoginPage nextPage = (LoginPage) getRequestCycle().getPage(LoginPage.PAGE_NAME);
		nextPage.activate();
	}
}
