package jumpstart.max.web.pages.starters;

import jumpstart.max.web.pages.login.LoginPage;

import org.apache.tapestry.annotations.Persist;
import org.apache.tapestry.html.BasePage;

public abstract class RestoreFromSessionPage extends BasePage {
	static public final String PAGE_NAME = "pages/starters/RestoreFromSessionPage";

	@Persist("session")
	// Actually, just @Persist would do, because "session" is the default strategy
	public abstract String getFirstName();
	public abstract void setFirstName(String value);

	@Persist("session")
	// Actually, just @Persist would do, because "session" is the default strategy
	public abstract String getLastName();
	public abstract void setLastName(String value);

	public void activate() {
		setFirstName("");
		setLastName("");
		getRequestCycle().activate(this);
	}

	public void activateWithRestore() {
		// The fields will be restored automatically because they are annotated with @Persist("session")
		getRequestCycle().activate(this);
	}

	public void doNext() {
		RestoreFromSessionPage2 nextPage = (RestoreFromSessionPage2) getRequestCycle().getPage(
				RestoreFromSessionPage2.PAGE_NAME);
		nextPage.activate();
	}

	public void doToLogin() {
		LoginPage nextPage = (LoginPage) getRequestCycle().getPage(LoginPage.PAGE_NAME);
		nextPage.activate();
	}
}